/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mitaka.h"
#include  "mtk_mode.h"
#include  "mtk_planet_phys_params.h"
#include  "mtk_solar_system.h"
#include  "mtk_planets.h"
#include  "mtk_planet_position.h"
#include  "mtk_switches.h"


//-------------
//  f̖O
//-------------
const bilingual bszPlanet[] = {
	{ "Mercury",	"{|}"			},
	{ "Venus",		"{|񂹂}"			},
	{ "Earth",		"{n|イ}"			},
	{ "Mars",		"{ΐ|}"			},
	{ "Jupiter",	"{ؐ|}"			},
	{ "Saturn",		"{y|ǂ}"			},
	{ "Uranus",		"{V|Ă̂}"	},
	{ "Neptune",	"{C|}"	},
	{ "Pluto",		"{|߂}"	}
};

bilingual
get_planet_name(int idx)
{
	return  bszPlanet[idx];
}


//------------
//  ff[^
//------------
struct planet_info {
	double	Re;			// ԓa(km)
	double  f;			// G
	bool	hasRing;	// ւ
	double  Rr1, Rr2;	// ւ̓aAOaiԓaPʂƂāj
};

const planet_info plnti[] = {
	{  2439.7,  0.0,	false, 0, 0 },			// 
	{  6051.8,  0.0,	false, 0, 0 },			// 
	{  6378.14, 0.0034, false, 0, 0 },			// n
	{  3396.19, 0.0052, false, 0, 0 },			// ΐ
	{ 71492,    0.065,  false, 0, 0 },			// ؐ
	{ 60268,    0.108,  true,  1.236, 2.270 },	// y
	{ 25559,    0.023,  true,  1.487, 2.001 },	// V
	{ 24764,    0.017,  false, 0, 0 },			// C
	{  1153,    0.0,    false, 0, 0 }			// 
};

//--- ԓa(km) ---
double
get_planet_Re(int mode, int idx)
{
	double fac = (mode == MODE_3D)  ?  get_zoom_rate().zmhPlanet  :  get_zoom_rate().zmpPlanet;
	return  fac * plnti[idx].Re;
}

double
get_planet_real_Re(int idx)
{
	return  plnti[idx].Re;
}

//--- G ---
double
get_planet_f(int idx)
{
	return plnti[idx].f;
}

bool
hasPlanetRing(int idx)
{
	return plnti[idx].hasRing;
}

void
get_planet_ring_radius(int idx, double* Rr1, double* Rr2)
{
	*Rr1 = plnti[idx].Rr1;
	*Rr2 = plnti[idx].Rr2;
}
