/******************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEF
Avj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ
܂Bɂ́A\tgEFA̕gpAʁAύXAAfځAЕzATu
CZXA/܂͔̔錠Aу\tgEFA񋟂鑊ɓ
Ƃ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
Lڂ̂Ƃ܂B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KAьN
QɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B ҂܂͒
쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tgEFAɋN܂
֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
*******************************************************************************/
#ifndef __FRAME_H__
#define __FRAME_H__
#include  "../math/vector3.h"
#include  "../math/quaternion.h"


//---------
//  Frame
//---------
template  <class T>
class frame
{
public:
	vector3<T>		r;		// position of origin
	quaternion<T>	ori;	// orientation
public:
	frame() : r(0,0,0), ori(1,0,0,0) {};
	frame(const vector3<T>& r0, const quaternion<T>& ori0) : r(r0), ori(ori0) {};
	frame(const vector3<T>& r0, const vector3<T>& eF, const vector3<T>& eU);

	void	reset() { r.set(0,0,0); ori.set(1,0,0,0); }
	void	set_axes(const vector3<T>& eF, const vector3<T>& eU);
	void	get_axes(vector3<T>& eF, vector3<T>& eU, vector3<T>& eR) const;
};

template  <class T>
frame<T>::frame(const vector3<T>& r0, const vector3<T>& eF, const vector3<T>& eU) : r(r0)
{
	ori = axes_to_quaternion(eF, eU);
}

template  <class T>
void
frame<T>::set_axes(const vector3<T>& eF, const vector3<T>& eU)
{
	ori = axes_to_quaternion<T>(eF, eU);
}

template  <class T>
void
frame<T>::get_axes(vector3<T>& eF, vector3<T>& eU, vector3<T>& eR) const
{
	quaternion_to_axes<T>(ori, eF, eU, eR);
}

//-- special version
typedef		frame<double>	framed;
typedef		frame<float>	framef;


#endif
